package cv04;

import java.util.Arrays;

public class CharFrontaPole {

	private char[] f;
	private int zacatek, konec;
	int n = 3;
	int sum = 0; //velikost pole
	
	public CharFrontaPole() {
		f = new char[n+1];
		zacatek = 0; 
		konec = 0;
	}
	
	boolean isEmpty(){
		return (zacatek == konec);
	}
	
	/* vloen znaku do fronty */
	void add(char c){
		f[konec++] = c; //naped vlo znak a potom inkrementuje
		konec = konec % (n+1);
		
		sum++;
		if(sum == n){
			f = zvetsiFrontu(f);
		}
	}

	/* Odebrn znaku z fronty */
	char poll(){
		char c = f[zacatek++];
		zacatek = zacatek % (n+1);
		
		sum--;
		if(sum < n/2){
			f = zmensiFrontu(f);
		}
		return c;
	}
	
	char peek(){
		return f[zacatek];
	}
	
	public String toString(){
		String s = "";
		for(int i = zacatek; i <= konec; i++){
			s += f[i];
		}
		return s;
	}
	
	char[] zvetsiFrontu(char[] fr){
		System.out.println("...zdojnsobuji frontu");
		return Arrays.copyOf(fr, n = n*2);
	}
	
	char[] zmensiFrontu(char[] fr){
		System.out.println("...redukuji frontu na polovinu");
		char[] newFr = new char[n = Math.max(2, sum+1)];
		int j = zacatek;
		for(int i = 0; i < sum; i++){
			newFr[i] = fr[j++];
		}
		zacatek = 0;
		konec = sum;
		return newFr;
	}
}
